//
// Created by william on 6/8/24.
//

#ifndef NES_EMULATOR_MAIN_WINDOW_H
#define NES_EMULATOR_MAIN_WINDOW_H

#include <SDL.h>
#include "../include/ppu.h"
#include "components/window.h"

#define MAIN_WINDOW_WIDTH 256
#define MAIN_WINDOW_HEIGHT 240
#define MAIN_WINDOW_SCALE 3

typedef struct nes_main_window {
    Window window;

    SDL_Texture *texture;
} NesMainWindow;

void main_window_init(NesMainWindow *window);
void main_window_uninit(NesMainWindow *window);

void main_window_render(NesMainWindow *window, pixel* pixels);
void main_window_mouse_motion(NesMainWindow *window, int x, int y);
void main_window_mouse_click(NesMainWindow *window);

#endif //NES_EMULATOR_MAIN_WINDOW_H
