//
// Created by william on 6/14/24.
//

#include "pattern_window.h"
#include "dbg_pattern_table.h"

#define PW_WIDTH (PW_ROW_TILE_COUNT * PATTERN_DRAW_SIZE)
#define PW_HEIGHT (PW_WIDTH * 2)
#define PW_BUFFER_SIZE (PW_WIDTH * PW_HEIGHT)

void pattern_window_init(NesPatternWindow *window) {
    window->window = window_create("Pattern Table", PW_WIDTH, PW_HEIGHT, PW_SCALE);
    window->texture = window_create_texture(&window->window, SDL_TEXTUREACCESS_STATIC);
    window->palette = 0;
}

void pattern_window_uninit(NesPatternWindow *window) {
    SDL_DestroyTexture(window->texture);
    window_destroy(&window->window);
}

void pattern_window_build_table(NesPatternWindow *window) {
    pixel buffer[PW_BUFFER_SIZE] = {0};
    dbg_pattern_draw_bank(PATTERN_BANK_0, buffer, window->palette);
    dbg_pattern_draw_bank(PATTERN_BANK_1, &buffer[PW_WIDTH * (PW_HEIGHT / 2)], window->palette);

    SDL_UpdateTexture(window->texture, NULL, buffer, PW_WIDTH * sizeof(pixel));
}

void pattern_window_key_up(NesPatternWindow *window, SDL_KeyCode keycode) {
    if (keycode != SDLK_o) {
        return;
    }

    window->palette++;
    if (window->palette > PW_PALETTE_MAX) {
        window->palette = 0;
    }

    pattern_window_build_table(window);
}

void pattern_window_render(NesPatternWindow *window) {
    window_render_texture(&window->window, window->texture);
}

void pattern_window_present(NesPatternWindow *window) {
    window_present(&window->window);
}